﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Pbm.dll;

using System;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using System.Transactions;
using Produmex.Sbo.Logex.Pbm;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;

namespace AddUserFieldsAndUserQueries
{
    class Program
    {
        //All most all user defined fields(UDF) can be added manual except these 2. Therefor this script can be used for doing that

        static string CONNECTION_STRING = "Server=pdmx-kardosp;CompanyDB=RB;ExtraDb=PMX_RB;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=manager;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2012;DBCultureInfo=en-US;LicenseServer=localhost:30000";

        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    

                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    AddUpdateExtension("PBM_OSO", "PBM open sales orders", typeof(Produmex.Sbo.Logex.Pbm.Generators.OpenSalesOrderController.PBMOpenSalesOrderWithStockController), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IOPENSALESORDERCONTROLLER, conn);
                    AddUpdateExtension("PBM_PPG", "PBM picklist proposals generator", typeof(Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTPROPOSALGENERATOR,conn);




                    AddUpdateExtensionParameter(
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtParamAddEmptyRowsForItemsWithInsufficientStock,
                        "Add empty rows to the picklist proposal for rows that have no stock? (Y/N)",
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                        "False",
                        PmxExtensionParameterCodes.PICKLIST_PROPOSAL_GENERATOR_GENERAL_ADD_EMPTY_ROWS_FOR_ITEMS_WITH_INSUFFICIENT_STOCK, conn);

                    AddUpdateExtensionParameter(
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtParamOrderByFields,
                        "Stock order by",
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
                        PmxFreeStockOrderByCodes.FEFO_PICKLOCATION,
                        PmxExtensionParameterCodes.PICKLIST_PROPOSAL_STOCK_ORDER_BY, conn);

                    AddUpdateExtensionParameter(
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtParamBaseDocumentOrderByFields,
                        "Base document - order by",
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
                        PmxBaseDocumentOrderByCodes.DOC_DUE_DATE,
                        PmxExtensionParameterCodes.PICKLIST_PROPOSAL_BASE_DOCUMENT_ORDER_BY, conn);

                    AddUpdateExtensionParameter(
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtParamAddEmptyRowsWhenQtyIsZero,
                        "Add empty row when ToPick is zero? (Y/N)",
                        Produmex.Sbo.Logex.Pbm.Generators.PickListProposalGenerators.PBMGroupedCustomerPickListProposalGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                        "False",
                        PmxExtensionParameterCodes.PICKLIST_PROPOSAL_GENERATOR_GENERAL_ADD_EMPTY_ROWS_FOR_ITEMS_WITH_QTY_TO_RESERVE_ZERO, conn);





                }

                //Complete transaction
                scope.Complete();
            }
        }


        /// <summary>
        /// Add/Update <see cref="PmxExtensionParameter"/>
        /// </summary>
        /// <param name="code">The code of the extension parameter.</param>
        /// <param name="name">The name of the extension parameter.</param>
        /// <param name="extensionCode">The extension code.</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="defaultValue">The default value.</param>
        /// <param name="generalParameterCode">The general parameter code.</param>
        private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, SboConnection conn)
        {
            PmxExtensionParameterProvider prov = new PmxExtensionParameterProvider(conn);
            PmxExtensionParameter extParam = null;
            try
            {
                bool newBO = false;
                extParam = prov.GetBO(code);
                if (extParam == null)
                {
                    newBO = true;
                    extParam = prov.GetNewBO();
                    extParam.Code = code;
                }
                extParam.Name = name;
                extParam.ExtensionCode = extensionCode;
                extParam.ConvertorCode = convertorCode;
                extParam.DefaultValue = defaultValue;
                extParam.GeneralParameterCode = generalParameterCode;
                if (newBO)
                {
                    prov.AddBO(extParam);
                }
                else
                {
                    prov.UpdateBO(extParam, false, false);
                }
            }
            finally
            {
                if (extParam != null) extParam.Dispose();
            }
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type , string extensionTypeCode, SboConnection conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider(conn);
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO(code);
                if (extension == null)
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
                if (newBO)
                {
                    prov.AddBO(extension);
                }
                else
                {
                    prov.UpdateBO(extension, false, false);
                }
            }
            finally
            {
                if (extension != null) extension.Dispose();
            }
        }
    }
}
