-- =============================================
-- Author:		Produmex
-- Create date: 
-- Description:	Delivery document by sales order
-- =============================================
ALTER PROCEDURE [dbo].[PMX_PBM_SP_DeliveryDocumentSalesOrder] 
	-- Parameters for the stored procedure
	@salesDeliveryNoteDocEntry int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

SELECT     TOP (100) PERCENT dbo.ODLN.DocEntry,dbo.ODLN.CardCode ,dbo.ODLN.CardName, dbo.ODLN.Address2 AS Address, ISNULL(dbo.RDR1.Quantity, 0) AS OrderQuantity, 
                      dbo.ORDR.DocNum, dbo.PMX_ITRI.BestBeforeDate, dbo.ODLN.DocDate, dbo.ODLN.DocNum AS DeliveryDocNum, 
                      dbo.PMX_ITRI.BatchNumber AS BatchNum, SUM(dbo.PMX_INVD.Quantity) * - 1 AS DeliveredQuantity, dbo.PMX_INVD.ItemCode, 
                      dbo.PMX_INVD.ItemName AS Dscription,
					  dbo.OSLP.SlpName As VerkoopsMedewerker	
FROM         dbo.DLN1 INNER JOIN
                      dbo.ODLN ON dbo.DLN1.DocEntry = dbo.ODLN.DocEntry INNER JOIN
                      dbo.PMX_INVD ON dbo.DLN1.DocEntry = dbo.PMX_INVD.DocEntry AND dbo.ODLN.ObjType = dbo.PMX_INVD.TransType AND 
                      dbo.DLN1.LineNum = dbo.PMX_INVD.DocLineNum INNER JOIN
                      dbo.PMX_LUID ON dbo.PMX_INVD.LogUnitIdentKey = dbo.PMX_LUID.InternalKey LEFT OUTER JOIN
                      dbo.ORDR INNER JOIN
                      dbo.RDR1 ON dbo.ORDR.DocEntry = dbo.RDR1.DocEntry ON dbo.DLN1.BaseEntry = dbo.RDR1.DocEntry AND 
                      dbo.DLN1.BaseLine = dbo.RDR1.LineNum AND dbo.DLN1.BaseType = dbo.ORDR.ObjType
						LEFT JOIN PMX_ITRI on pmx_itri.internalkey = pmx_invd.itemtransactionalinfoKey INNER JOIN
					  dbo.OSLP ON dbo.ODLN.SlpCode = dbo.OSLP.SlpCode	
WHERE     (dbo.ODLN.DocEntry  = @salesDeliveryNoteDocEntry)
GROUP BY dbo.ODLN.DocEntry, dbo.ORDR.DocNum, dbo.PMX_ITRI.BestBeforeDate, dbo.ODLN.CardCode ,dbo.ODLN.CardName, dbo.ODLN.Address2, dbo.ODLN.DocDate, 
                      dbo.ODLN.DocNum, dbo.RDR1.Quantity, dbo.PMX_ITRI.BatchNumber, dbo.PMX_INVD.ItemCode, dbo.PMX_INVD.ItemName, dbo.OSLP.SlpName 
	
END
